/* c++ ed */
#include <stdlib.h>

#include "biblosimpl.h"
#include "fielditem.h"
#include "easycopylist.h"

#include <qbitmap.h>
#include <qcombobox.h>
#include <qcursor.h>
#include <qdragobject.h>
#include <qfiledialog.h>
#include <qpopupmenu.h>
#include <qstatusbar.h>
#include <qtimer.h>
#include <qtoolbutton.h>
#include <qcursor.h>
#include <qsettings.h>

#include <qdir.h>
#include <string.h>


QWidget *Logo;
FieldItem *LCollections=NULL,*LMedias=NULL;


int NameChanged = 0 , FileChanged = 0;
QString FileName;
Field *BaseTree;
QPixmap *IconDirClosed , *IconFileRegular ;

QPixmap uic_load_pixmap( const QString &name )
{
    const QMimeSource *m = QMimeSourceFactory::defaultFactory()->data( name );
    if ( !m )
	return QPixmap();
    QPixmap pix;
    QImageDrag::decode( m, pix );
    return pix;
}



/*
QPoint oldMousePos(0,0);

void TForm::mouseMoveEvent(QMouseEvent *e){
 if( abs(oldMousePos.x() - e->x()) < 2 && abs(oldMousePos.y() - e->y()) < 2 ) 
	return;
 move(e->globalPos()+e->pos());
 oldMousePos.setX(e->x());
 oldMousePos.setY(e->y());
}
*/


void TForm::contextMenuRequested( QListViewItem *it, const QPoint &point, int col){
	if( col == -1 ) return;
	BAddMToCol->popup()->exec(point,0);
}
TForm::TForm()
	:Form1()
{
  hide();
//displaying the logo

    Logo = new QWidget();
    Logo->mapToGlobal(QPoint(500,400));
    Logo->show();

//    QBitmap m=uic_load_pixmap( "1mask.png" );
    QPixmap p=uic_load_pixmap( "1.png");

//    QBitmap *m=(QBitmap)new QPixmap("1mask.bmp",0);
//    QPixmap p("1.bmp",0,QPixmap::Auto);


    Logo->setErasePixmap(p);
    Logo->setMask(p.createHeuristicMask());


    QTimer::singleShot( 2000,Logo,SLOT(hide()) ); // 2 seconds single-shot timer
    QTimer::singleShot( 2000,this,SLOT(show()) ); // 2 seconds single-shot timer

// end of logo display
  statusBar()->addWidget( ProgressBar = new QProgressBar( 32000 , statusBar() , 0 , 0 ) , 0 , TRUE ) ;
  ProgressBar->setMaximumSize( 150 , 20 ) ;
  ProgressBar->setCenterIndicator( TRUE ) ;


  IDXFile_New();

	
  LList->setColumnAlignment( 1 , Qt::AlignRight ) ;
  LList->setColumnAlignment( 2 , Qt::AlignRight ) ;
  LList->setColumnAlignment( 3 , Qt::AlignRight ) ;
  LList->setColumnAlignment( 4 , Qt::AlignRight ) ;
  
//  IconDirClosed = new QPixmap( "mc/i-dirclosed.png" );
//  IconFileRegular = new QPixmap( "mc/i-regular.png" );

  setCursor( QCursor(PointingHandCursor) );
  connect( LTree,SIGNAL(contextMenuRequested( QListViewItem *, const QPoint &, int )),
	  this, SLOT( contextMenuRequested( QListViewItem *, const QPoint &, int ) ) );
  connect( LList,SIGNAL(contextMenuRequested( QListViewItem *, const QPoint &, int )), 
	  this, SLOT( contextMenuRequested( QListViewItem *, const QPoint &, int ) ) );
  //connect( MyFindDialog.LFind,SIGNAL(contextMenuRequested( QListViewItem *, const QPoint &, int )), 
	//  this, SLOT( contextMenuRequested( QListViewItem *, const QPoint &, int ) ));

	    

//  ProgressBar->hide();

  BLang->setPopup( new QPopupMenu(BLang,"menu") );
  BLang->popup()->setCheckable(true);

  QSettings settings;
#ifdef Q_WS_WIN
  settings.insertSearchPath( QSettings::Windows, "/Biblos" );
#endif
  if(settings.readEntry( "/biblos/lang file", "/opt/biblos/biblos_en" )== "/opt/biblos/biblos_en" )
    BLang->popup()->setItemChecked(BLang->popup()->insertItem(tr("English"),0),true);
  else BLang->popup()->insertItem(tr("English"),0);

  if(settings.readEntry( "/biblos/lang file", "/opt/biblos/biblos_en" )== "/opt/biblos/biblos_ro" )
	BLang->popup()->setItemChecked(BLang->popup()->insertItem(tr("Romanian"),1),true);
  else BLang->popup()->insertItem(tr("Romanian"),1);
  
  connect( BLang->popup(),SIGNAL(activated(int)), this, SLOT( toggleLang(int) ) 
);

  
}

TFindDialog::TFindDialog( QWidget *parent , const char *name , bool modal , WFlags fl )
	:  FindDialog( parent , name , modal , fl )
{
  LFind->setColumnAlignment( 2 , Qt::AlignRight ) ;
  LFind->setColumnAlignment( 3 , Qt::AlignRight ) ;
  LFind->setColumnAlignment( 4 , Qt::AlignRight ) ;
  LFind->setColumnAlignment( 5 , Qt::AlignRight ) ;

}


void TForm::recurse_addToCollection(Field *item,QString col,QString filter){

if(filter != NULL )
  if(item->collectionslist.contains(filter) == 0 ) return;

if( item->collectionslist.length() == 0 )
	item->collectionslist = "\"" ;

item->collectionslist += col ;
item->collectionslist += "\"";


for(Field *it=item->sons;it!=NULL;it=it->nextbrother)
	recurse_addToCollection(it,col,filter );
		
}


void TForm::Obj_addToCollection(int id){//attention : when adding this function as a slot don't forget to put( int ) as param
QListViewItem *itl,*col_ptr=NULL;
QListViewItemIterator *it;


  //create new collection if New collection ... is chosen
  if(BAddMToCol->popup()->findItem(id)->text()==tr("New Collection...")){
	
    LCollections->setOpen(TRUE);
    FieldItem *col_ptr=new FieldItem(LCollections,tr("My Collection no ")+QString::number(rand()));

    col_ptr->startRename(0);
   return;
  }

// cautam poz in ltree a colectiei
  for( it=new QListViewItemIterator(LCollections) ; it->current()!=NULL ; ++(*it) )
    if(it->current()->parent()==LCollections){
		  
	//QMessageBox::warning(this,"",it->current()->text(0)+BAddMToCol->popup()->findItem(id)->text(),QMessageBox::Ok,0,0);
	  if( it->current()->text(0)==BAddMToCol->popup()->findItem(id)->text()){
		col_ptr=it->current();
		break;
	  }
    }

  /*unuseful assertion
  if(col_ptr==NULL){
	  
	  QMessageBox::warning(this,"invalid collection","",QMessageBox::Ok,0,0);
	  return;
  }*/

 
  if( LTree->hasFocus() && LTree->selectedItem())
   if( LTree->selectedItem()->parent() != LCollections && LTree->selectedItem()->parent() != NULL ){

	for( it=new QListViewItemIterator(col_ptr) ; it->current()!=NULL ; ++(*it) )
	  if(it->current()->parent()==col_ptr)
	    if( ((FieldItem *)(it->current()))->getField()==((FieldItem *)(LTree->selectedItem()))->getField() ){
		QMessageBox::warning(this,tr("Object already added"),tr("The object \"") + LTree->selectedItem()->text(0) + tr("\" already exists in collection \"")+ col_ptr->text(0) + tr("\" . It will no be added again !") , QMessageBox::Ok,0,0);
		  return;
		}


		if( ((FieldItem *)(LTree->selectedItem()))->getField()->collectionslist.length() == 0 )
			((FieldItem *)(LTree->selectedItem()))->getField()->collectionslist = "\"" ;

		((FieldItem *)(LTree->selectedItem()))->getField()->collectionslist += col_ptr->text(0) ;
		((FieldItem *)(LTree->selectedItem()))->getField()->collectionslist += "#\"";
		
		for(Field *it=((FieldItem *)(LTree->selectedItem()))->getField()->sons;it!=NULL;it=it->nextbrother)
		  recurse_addToCollection( it , col_ptr->text(0) ,( ( ((FieldItem *)(LTree->selectedItem()))->Collection != NULL ) ? ((FieldItem *)(LTree->selectedItem()))->Collection->text(0) : NULL ) );
		
	new FieldItem((FieldItem *)(col_ptr),((FieldItem *)(LTree->selectedItem()))->getField() ,FALSE  , (FieldItem *)(col_ptr) );				
		return;

   } else QMessageBox::warning(this,tr("Warning"),tr("You cannot add a collection to another collection - instead add all source collection's objects to the destination collection !"),QMessageBox::Ok,0,0);
  

    
//both can have focus

  if( LList->hasFocus() )
    for (itl = LList->firstChild() ; itl ; itl = itl->nextSibling() )

	  if( LList->isSelected( itl ) ){

		for( it=new QListViewItemIterator(col_ptr) ; it->current()!=NULL ; ++(*it) )
			if(it->current()->parent()==col_ptr)	
			if( ((FieldItem *)(it->current()))->getField()==((FieldItem *)(itl))->getField() ){
				QMessageBox::warning(this,tr("Object already added"),tr("The object \"") + itl->text(0) +
					tr("\" already exists in collection \"") + col_ptr->text(0) + tr("\" . It will no be added again !") , QMessageBox::Ok,0,0);
	
			  break;
			}


		if( it->current() != NULL )	 continue;  // item already added
				
		if( ((FieldItem *)(itl))->getField()->collectionslist.length() == 0 )
		  ((FieldItem *)(itl))->getField()->collectionslist = "\"";

		((FieldItem *)(itl))->getField()->collectionslist += col_ptr->text(0);
		((FieldItem *)(itl))->getField()->collectionslist += "#\"";
		
		for(Field *it=((FieldItem *)(itl))->getField()->sons;it!=NULL;it=it->nextbrother)
			recurse_addToCollection( it , col_ptr->text(0) ,( (((FieldItem *)(itl))->Collection !=NULL) ? ((FieldItem  *)(itl))->Collection->text(0):NULL) );
				
	    new FieldItem((FieldItem *)(col_ptr),((FieldItem *)(itl))->getField() ,FALSE ,  (FieldItem *)(col_ptr) );
					
	  }


}
void TForm::LTree_selectionChanged(QListViewItem *itchanged){	//executed at cr item changed in LTree
//asta tb modificata pt precache-ing - dar ma grabesc si nu am timp
FieldItem *itc = (FieldItem *)itchanged ;


 LList->clear();

 for( Field *child = itc->getField()->sons ; child != NULL ; child = child->nextbrother ){
   if( itc->Collection != NULL ){//collection filter applies

     if( child->collectionslist.isEmpty()||child->collectionslist.isNull()) continue ;//collection filter applies
     //fucking impossible : strstr stopped here at the second "
     if( child->collectionslist.contains( "\"" +  itc->Collection->text(0) + "\"" , TRUE) ==0 ) continue ;

     FieldItem *temp= new FieldItem( LList , child , TRUE , itc->Collection ) ;

   } else
     new FieldItem( LList , child , TRUE , NULL ) ;
 }

 statusBar()->message(tr("Objects in folder : ")+QString::number(LList->childCount(),10));

}

void TForm::BrowseDir(QListViewItem *itchanged){//at llist/find/ecl double-click-ed

  if( ((FieldItem *)(itchanged))->getField()->id=='f') return;
  if( ((FieldItem *)(itchanged))->getField()->ltree == NULL ) {
    QMessageBox::warning(this,"","void TForm::BrowseDir(QListViewItem *itchanged) : null field",QMessageBox::Ok,0,0);
	return;	}//it must not happend !!!
  
  LTree_selectionChanged( ((FieldItem *)(itchanged))->getField()->ltree );
  LTree->setOpen( ((FieldItem *)(itchanged))->getField()->ltree,TRUE);
  LTree->setSelected( ((FieldItem *)(itchanged))->getField()->ltree,TRUE);
    
  //MyForm->setFocus();
}

/* working area 

void TForm::FreeTree( Field *tree ){//not necessary
Field *tt ;

  while( tree != NULL ){

    tt = tree ;
    tree = tree->nextbrother ;

//    qDebug("freeing class");
      //delete (tt->ltree);
      //delete (tt->llist);
//    qDebug("class freed");

//  for( QListViewItemIterator *it=new QListViewItemIterator(LCollections->firstChild()) ; it->current()!=NULL ; ++(*it) )
//	if( it->current()->parent() == LCollections )
//	  Obj_remCollection( tt,it->current() );
	  

    if( tt->sons != NULL ) FreeTree( tt->sons ) ;
    free( tt );

    //qDebug("%s %s rec", tt->name , (tt->sons != NULL )  ? "cu":"fara" );

  }

}

*/
void TForm::IDXFile_New()
{
//if( BaseTree == NULL ) return ;
  FileName.truncate( 0 );

  //if( FileChanged ) prompt for save;
 
  if( LCollections != NULL ) delete LCollections;
  if( LMedias != NULL ) delete LMedias;

  MyFindDialog.LFind->clear();
  MyEasyCopyList.LECL->clear();
  LList->clear();
  LTree->clear();
  

  LCollections=new FieldItem( LTree , QString("Collections") );
  LMedias=new FieldItem( LTree , QString("Medias") );

  LCollections->getField()->ltree=LCollections;
  LMedias->getField()->ltree=LMedias;



  delete BAddMToCol->popup();
  BAddMToCol->setPopup( new QPopupMenu( BAddMToCol , "menu2" ) );
  //BAddMToCol->popup()->insertTearOffHandle(-1,-1);
  //connect( BAddMToCol->popup(),SIGNAL(activated(int)), this, SLOT( Obj_addToCollection(int) ) );
  BAddMToCol->popup()->insertItem(tr("New Collection..."),this,SLOT(Obj_addToCollection(int)),0,-1,-1);
  BAddMToCol->popup()->insertItem(tr("Delete Object..."),this,SLOT(Obj_Del()),0,-1,-1);
  BAddMToCol->popup()->setItemEnabled(BAddMToCol->popup()->insertItem(tr("To Existing Collection :"),this,SLOT(Obj_addToCollection(int)),0,-1,-1),FALSE);
  BAddMToCol->popup()->insertSeparator(-1);
  //MyFindDialog.BAddFToCol->setPopup(BAddMToCol->popup());
  //connect( BAddMToCol,SIGNAL(clicked(void)),BAddMToCol,SLOT(openPopup(void)) );//!!! it does not work
  

  
  ProgressBar->reset();
  ProgressBar->show();

  qDebug("freeing...");
    delete BaseTree;
  qDebug("inapoi");


  BaseTree = NULL ;

}

void TForm::Col_NameChanged( QListViewItem *itchanged , int col , const QString &text ){
FieldItem *itc = ( FieldItem * )itchanged ;
//TODO:de fixuit items duplicate cand se apasa escape
if(col !=0) return;

  if( text.isNull() || text.isEmpty() ) {

	QMessageBox::warning(this,tr("Empty Collection Name"),tr("The Collection has an empty name.Please name the collection."),QMessageBox::Ok ,0,0);
	itc->startRename(0);
	return;

  }

  for( QListViewItemIterator *it=new QListViewItemIterator(LCollections->firstChild()) ; it->current()!=NULL ; ++(*it) )
	if(it->current()->parent()==LCollections)
	  if( !strcmp(text,(const char *)it->current()->text(0)) && it->current()!=itc) {
            QMessageBox::warning(this,tr("Duplicate Collection"),tr("The Collection already exists.Please use another name."),QMessageBox::Ok ,0,0);
	    itc->startRename(0);
	    return;
	  }

	delete BAddMToCol->popup();
	BAddMToCol->setPopup( new QPopupMenu( BAddMToCol , "menu2" ) );
	//BAddMToCol->popup()->insertTearOffHandle(-1,-1);
	BAddMToCol->popup()->insertItem(tr("New Collection..."),this,SLOT(Obj_addToCollection(int)),0,-1,-1);
	BAddMToCol->popup()->insertItem(tr("Delete Object..."),this,SLOT(Obj_Del()),0,-1,-1);
	BAddMToCol->popup()->setItemEnabled(BAddMToCol->popup()->insertItem(tr("To Existing Collection :"),this,SLOT(Obj_addToCollection(int)),0,-1,-1),FALSE);
	BAddMToCol->popup()->insertSeparator(-1);
	MyFindDialog.BAddFToCol->setPopup(BAddMToCol->popup());

for( QListViewItemIterator *it=new QListViewItemIterator(LCollections->firstChild()) ; it->current()!=NULL ; ++(*it) )
  if(it->current()->parent()==LCollections)
	BAddMToCol->popup()->insertItem(it->current()->text(0),this,SLOT(Obj_addToCollection(int)),0,-1,-1);
	  //if( !strcmp(text,(const char *)it->current()->text(0)) && it->current()!=itc) {

}

void PrintTree(Field *tree,int niv)
{
int k;

while( tree != NULL )
  {

   for(k=0;k<niv;k++) printf("-");
   printf("%s\n",tree->name.latin1());

   if( tree->sons != NULL )
     PrintTree( tree->sons , niv + 1 );

   tree = tree->nextbrother ;
  }
}


void TForm::BBrowse_SelectDir()
{
QString dirname(" ");
   dirname = QFileDialog::getExistingDirectory( QString::null, this , QString::null , tr("Choose directory") , TRUE ) ;
   if ( dirname.isEmpty() )
       {qWarning("BBrowse_SelectDir():string null") ; return ; }
   CPath->insertItem( dirname , 0 );

}

