#ifndef __BIBLOSIMPL_H__
#define __BIBLOSIMPL_H__


#include "biblos.h"
#include "finddialog.h"
#include "fielditem.h"
#include "easycopylist.h"

#include <qstring.h>
#include <stdlib.h>

#include <qapplication.h>
#include <qcursor.h>
#include <qlistview.h>
#include <qevent.h>
#include <qmessagebox.h>
#include <qobject.h>
#include <qpixmap.h>
#include <qprogressbar.h>
#include <qtextstream.h>
#include <qtranslator.h>


class FieldItem;
class FindDialog;
class EasyCopyList;
class TForm;
extern TForm *MyForm;
extern QApplication *a;
extern QTranslator *MyTranslator;


class Field{
  public:
	char id;
	QString name;
	QString size;
	QString time,date;
	QString uid,gid;
	QString user,group;
	QString perm;
	QString comment;
	//QString nextbrother;		//if id == d or v
	QString collectionslist;
	
//internal syncs - not used yet
	//char loaded;
	//char written;
	//char hasChld;		//if id == d or v
	
//internal gui pointers
	Field *parent , *prevbrother , *nextbrother , *sons ;
	FieldItem *ltree,*llist;	//llist poz in lista ; ltree poz in tree;
	QListViewItem *lecl;		//poz in ECL daca e deja acolo , altfel null

	Field():
	  name("") , size("") , time("") , date("") , uid("") , gid("") ,
	  user("") , group("") , perm("") , comment("") , collectionslist("") ,
	  parent(NULL) , prevbrother(NULL) , nextbrother(NULL) , sons(NULL) , 
	  ltree(NULL) , llist(NULL) , lecl(NULL) {}
	
	Field( char nid , QString nname , QString nsize , QString ntime, QString ndate , QString nuid , QString ngid ,
		QString nuser , QString ngroup , QString nperm , QString ncomment ,	QString ncollectionslist ,
		Field *nparent=NULL , Field *nprevbrother=NULL , Field *nnextbrother=NULL , Field *nsons=NULL) :

	  id(nid) , name(nname) , size(nsize) , time(ntime) , date(ndate) , uid(nuid) , gid(ngid) , user(nuser),
	  group(ngroup) , perm(nperm) , comment(ncomment) , collectionslist(ncollectionslist) ,
	  parent(nparent) , prevbrother(nprevbrother) , nextbrother(nnextbrother) , sons(nsons) {

	  ltree=llist=NULL;
	  lecl=NULL;
	}
	~Field(){
	    //llist=ltree=NULL;
	    //lecl=NULL;
		//QMessageBox::warning((QWidget *)MyForm , "","destructor of an FIELD named " + name , QMessageBox::Ok,0,0);
	}

};

class TEasyCopyList : public EasyCopyList
{
	Q_OBJECT
public:
	TEasyCopyList();
	QProgressBar *ProgressBar;

public slots:
	void ECL_Clear();
	void ECL_Remove();
	void ECL_Save();
	void BBrowseTo_SelectDir();
	void ECL_StartCopyingTo();
	int  copyFiles(QString dirfrom ,QString dirto,Field *fi);
};

class TFindDialog : public FindDialog
{
	Q_OBJECT
public:
	TFindDialog( QWidget *parent = 0, const char *name = 0, bool modal = FALSE, WFlags fl = 0 );

public slots:
	void Search();
	void DateEnabled( bool t ) ;
	void DateBetweenEnabled( int sel ) ;
	void TestConditions( Field *tree ) ;
	void FindInTree( Field *tree );
	void BrowseDir( QListViewItem *itchanged );

	void Obj_toECL_fromF();
};

class TForm : public Form1
{
	Q_OBJECT
public:
	TForm();
	TFindDialog MyFindDialog;
	TEasyCopyList MyEasyCopyList;
	QProgressBar *ProgressBar;
	
public slots:
//	void mouseMoveEvent(QMouseEvent *e);
	
	void toggleLang(int id);
	void contextMenuRequested( QListViewItem *, const QPoint &, int );
	void recurse_addToCollection(Field *it,QString col ,QString filter);
	
	
	void About();
	void Form1_Exit();
	
	void Obj_Add();
	void Obj_CommentChanged( QListViewItem *itchanged , int col , const QString &text );
	void Obj_Del();
	void Obj_Find();
	bool Obj_belongsToCol(Field *it,QListViewItem *col_ptr);
	void Obj_addToCollection(int id);
	void Obj_remCollection(FieldItem *it,QListViewItem *col_ptr,bool is_top_collection);


	void Col_NameChanged( QListViewItem *itchanged , int col , const QString &text );

	void LTree_selectionChanged( QListViewItem *itchanged );
	void BrowseDir(QListViewItem *itchanged);
	
	void LTree_unFocused();
	void LList_unFocused();
	
	void BBrowse_SelectDir();
    void IDXFile_New();
	void IDXFile_Open();
	int  IDXFile_Save();
	void IDXFile_SaveAs();
	void IDXFile_Import();

	Field *ReadTree( QString dirname , Field *parent );
	Field *ReadIDXFile( QTextStream *tstream , QString *path , Field *parent) ;
	void WriteIDXFile( QTextStream *tstream , Field *tree );

	void Obj_toECL_fromM();
};


QPixmap uic_load_pixmap( const QString &name );
void PrintTree( Field *tree , int niv );
//void RefreshLTree( Field *tree , QListViewItem *item );


extern QString FileName ;
extern Field *BaseTree ;
extern FieldItem *LCollections,*LMedias;

#endif
