/* cpp at fara nici o schimbare */
/***************************************************************************

                          ecl.cpp  -  description

  begin		: Fri Jul 19 2002
  copyright	: (C) 2002 by Dumitrascu Vasile
  email		: va511e@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "biblosimpl.h"
#include <qcombobox.h>
#include <qfiledialog.h>
#include <qmessagebox.h>
#include <qstatusbar.h>

TEasyCopyList::TEasyCopyList()
    :EasyCopyList()
{
    statusBar()->addWidget( ProgressBar = new QProgressBar( 32000 , statusBar() , 0 , 0 ) , 0 , TRUE ) ;
    ProgressBar->setMaximumSize( 150 , 20 ) ;
    ProgressBar->setCenterIndicator( TRUE ) ;
    //ProgressBar->hide();
}


void TEasyCopyList::ECL_Clear()
{QListViewItem *it,*temp ;

 it = LECL->firstChild() ;

    while ( it ){

       ((FieldItem *)(it))->getField()->lecl=NULL;
       temp=it;
       it=it->nextSibling();
       delete  temp;
    }
}

void TEasyCopyList::ECL_Remove()
{QListViewItem *it,*temp ;

  it = LECL->firstChild() ;
     while ( it ){
       if( LECL->isSelected( it ) ){
      	 ((FieldItem *)(it))->getField()->lecl=NULL;
      	 temp=it;
      	 it = it->nextSibling();
      	 delete temp ;
      	 continue;
	}
       it = it->nextSibling();
      }
 
}

void TEasyCopyList::ECL_Save()
{QListViewItem *it;
 QString FileToSave;

 FileToSave += QFileDialog::getSaveFileName( QString::null,
                    "*.lst",
                    this,
                    tr("Save easy copy list"),
                    tr("Choose a filename to save the list under") );
	 
	 //QString::null, "*.lst", this ) ;

 if ( FileToSave.isEmpty() ){
   qWarning("IDXFile_Save():string null") ;
   return ;
 }

  QFile f( FileToSave );
  if( !f.open( IO_WriteOnly ) ) return; //an error had happened here

// qWarning("file opened");
  QTextStream tstream( &f ) ;
// qWarning("writing file");

   it = LECL->firstChild() ;

    while ( it ){
      tstream << it->text(1)<<it->text(0)<<"\n";
       it=it->nextSibling();
    }


     f.close() ;

}

void TEasyCopyList::BBrowseTo_SelectDir()
{QString dirname(" ");
   dirname = QFileDialog::getExistingDirectory( QString::null, this , QString::null , tr(" Choose target directory") , TRUE ) ;
   if ( dirname.isEmpty() )
       {qWarning("BBrowse_SelectDir():string null") ; return ; }
   CPathToCopyTo->insertItem( dirname , 0 );

}


void TEasyCopyList::ECL_StartCopyingTo()
{QListViewItem *it ;
 QDir dir( CPathToCopyTo->currentText() );
 char temp[256];

 if ( !dir.exists() ){
   QMessageBox::critical(this,"ENODIR",tr(" The specified target directory does not exist ! "),QMessageBox::Ok,0,0);
   return ;
 }

 it = LECL->firstChild() ;
 if( it == NULL ){
   QMessageBox::critical(this,tr("Warning"),tr(" The list is empty ! "),QMessageBox::Ok,0,0);
   return ;
 }


    while ( it ){
      strcpy(temp,tr(" Please make sure that the volume containing "));
      strcat(temp,it->text(1));
      strcat(temp,it->text(0));
      strcat(temp,tr(" is mounted in the specified place "));
      QMessageBox::warning(this,tr("Attention"),temp,QMessageBox::Ok,0,0);

      copyFiles( it->text(1) + it->text(0) , CPathToCopyTo->currentText() , ((FieldItem *)(it))->getField() );
      it=it->nextSibling();
    }
}

int TEasyCopyList::copyFiles(QString from,QString dirto,Field *fi)
{char tempout[256],tempin[256],msg[256];


  if ( fi->id == 'f' ){
    strcpy(tempout,dirto);//atentie - dir poate sa nu se termine in /
    if( tempout[strlen(tempout)-1]!='/') strcat(tempout,"/");
    strcat(tempout,fi->name);
    QFile fout(tempout);


  // checking source file existence
    QFile fin(from);


    if( !fin.exists() ){
      strcpy(msg,tr("The source file \""));
      strcat(msg,from);
      strcat(msg,tr("\" does not exist ! Skipping it !") );
      QMessageBox::warning(this,tr("Could not copy file ..."),msg,QMessageBox::Ok,0,0);
      return -1;
    }

  // checking source read permission
    if( !fin.open(IO_ReadOnly | IO_Raw) ){
      strcpy(msg,tr("The source file "));
      strcat(msg,from);
      strcat(msg,tr(" cannot be read ! Skipping it !") );
      QMessageBox::warning(this,tr("Could not copy file ..."),msg,QMessageBox::Ok,0,0);
      return -2;
    }

  // checking target creation permission
    if( !fout.open(IO_WriteOnly | IO_Raw | IO_Truncate ) ){
      strcpy(msg,tr("The target file ") );
      strcat(msg,tempout);
      strcat(msg,tr(" cannot be created ! Skipping it !") );
      QMessageBox::warning(this,tr("Could not copy file ..."),msg,QMessageBox::Ok,0,0);
      return -3;
    }

  // lets write the file
    char buffer[4096];
    Q_LONG size,fsize=0;
    strcpy(msg,tr("Copying "));
    strcat(msg,fi->name);
    strcat(msg," ... ");

    statusBar()->message(msg);
    ProgressBar->setProgress(0);
    ProgressBar->show();
    update();
    while( ( size = fin.readBlock(buffer,4096)) > 0 ){
      fout.writeBlock(buffer,size);
      fsize+=size;
      ProgressBar->setProgress((int)(fsize/(double)(fin.size())*32000));
    }
    statusBar()->clear();
    //ProgressBar->hide();
    fin.close();
    fout.close();
    return 0;
  }

  if ( fi->id == 'v' || fi->id == 'd' ){

    QDir dirin(from);

    if ( !dirin.exists() ){
      strcpy(msg,tr("The source directory \"") );
      strcat(msg,from);
      strcat(msg,tr("\" does not exist ! Skipping it !") );
      QMessageBox::warning(this,tr("Could not open directory ..."),msg,QMessageBox::Ok,0,0);
      return -1;
    }

  // checking source read permission
    if( !dirin.isReadable() ){
      strcpy(msg,tr("The source dir ") );
      strcat(msg,from);
      strcat(msg,tr(" cannot be read ! Skipping it !") );
      QMessageBox::warning(this,tr("Could not open dir ..."),msg,QMessageBox::Ok,0,0);
      return -2;
    }

  // checking target creation permission
    strcpy(tempout,dirto);
    if( tempout[strlen(tempout)-1]!='/') strcat(tempout,"/");
    strcat(tempout,fi->name);

    QDir dirout(tempout);
    if( !dirout.exists() ){
      if( !dirout.mkdir(tempout,TRUE) ){
        strcpy(msg,tr("The target directory ") );
        strcat(msg,tempout);
        strcat(msg,tr(" cannot be opened nor created ! Skipping it !") );
        QMessageBox::warning(this,tr("Could not access directory ..."),msg,QMessageBox::Ok,0,0);
        return -3;
      }
    }
//    if( !dirout.isWritable() ) - this shit cannot be checked

  // lets traverse the directory
    for(Field *t= fi->sons ; t ; t=t->nextbrother ){
      strcpy(tempin,from);
      if( tempin[strlen(tempin)-1]!='/')strcat(tempin,"/");
      strcat(tempin,t->name);

      copyFiles( tempin , tempout , t);
    }
    return 0;
  }

  return -100;
}
