/* converted to c++ mode */
#include "biblosimpl.h"
#include <qcombobox.h>
#include <qdir.h>
#include <qmessagebox.h>
#include <qstatusbar.h>
#include <qstring.h>

QString MakePerm( QFileInfo *fi )
{int perm = 0 ;
 char tperm[4] ;
 
  
 if( fi->permission( QFileInfo::ReadUser ) ) perm+= 400 ;
 if( fi->permission( QFileInfo::WriteUser ) ) perm+= 200 ;
 if( fi->permission( QFileInfo::ExeUser ) ) perm+= 100 ;

 if( fi->permission( QFileInfo::ReadGroup ) ) perm+= 40 ;
 if( fi->permission( QFileInfo::WriteGroup ) ) perm+= 20 ;
 if( fi->permission( QFileInfo::ExeGroup ) ) perm+= 10 ;
  
 if( fi->permission( QFileInfo::ReadOther ) ) perm+= 4 ;
 if( fi->permission( QFileInfo::WriteOther ) ) perm+= 2 ;
 if( fi->permission( QFileInfo::ExeOther ) ) perm+= 1 ;
 sprintf( tperm , "%d" , perm );

 return QString(tperm);
}


void TForm::Obj_Add( )
{QString dirname;
QDir dir( CPath->currentText() );
Field *ttree,*ti;
char tmp[256];

  if( CPath->currentText().isNull() ) return ;
  dirname = CPath->currentText() ;

  if ( !dir.exists() )
        {
         //qWarning( "ENODIR" );
         QMessageBox::critical(this,tr("ENODIR"),tr(" This directory does not exist ! "),QMessageBox::Ok,0,0);
         return;
        }

// FILL attrs

  QFileInfo fi( dir.absPath() ) ;
  //				id		name		size							time
  ttree = new Field( 'v' , dirname , QString::number( fi.size()) , fi.lastModified().time().toString() ,
  //	date									uid									gid
	  fi.lastModified().date().toString() , QString::number( fi.ownerId() ) ,QString::number( fi.groupId() ),
  //	user		group		perm			comment collectionslist
      fi.owner() , fi.group() , MakePerm( &fi ) , " " , "" );

  if( BaseTree == NULL ){

    BaseTree = ttree;

  } else {

     for( ti = BaseTree ; ti->nextbrother != NULL ; ti = ti->nextbrother ) ;
     ti->nextbrother = ttree;
	 ttree->prevbrother = ti ;
  }


  QApplication::setOverrideCursor( Qt::WaitCursor );
  ttree->sons = ReadTree( dirname , ttree );
  QApplication::restoreOverrideCursor();
     
  LList->clear();
  statusBar()->clear();

  new FieldItem( LMedias , ttree , TRUE , NULL ) ;

}

Field *TForm::ReadTree( QString dirname , Field *parent )
{QDir dir( dirname );
 char tmp[256];   
 Field *Tree , *iTree = NULL ,*ttree;
  
  if ( !dir.exists() ) return NULL;
  if ( !dir.isReadable() ) return NULL;
  
  dir.setFilter( QDir::Dirs | QDir::Files | QDir::Hidden );
  dir.setSorting( QDir::Name );


const QFileInfoList *list = dir.entryInfoList();
QFileInfoListIterator it( *list );      // create list iterator
QFileInfo *fi;                          // pointer for traversing

  while( (fi=it.current())!=0 )
    {
     if( !strcmp( fi->fileName() , ".") || !strcmp( fi->fileName() , ".." ) )
       {++it ; continue; }
     if( fi->isSymLink() )
       {++it ; continue; }

 //qWarning( fi->fileName().data() );


  //					id						name			size								time
  ttree = new Field( (fi->isDir() ? 'd':'f') , fi->fileName() , QString::number( fi->size() ) , fi->lastModified().time().toString() ,
  //	date									uid										gid
	fi->lastModified().date().toString() , QString::number( fi->ownerId() ) , QString::number( fi->groupId() ) ,
  //	user		group
	fi->owner() , fi->group() , MakePerm( fi ) , " " , "" , parent );

 if ( iTree != NULL ){

    Tree->nextbrother = ttree;
	Tree->nextbrother->prevbrother = Tree ;
    Tree = Tree->nextbrother ;

 } else {

	 iTree = Tree = ttree ;
 
 }

 
    
     if( fi->isDir() )
       {
        //      qWarning( adir ) ;
		statusBar()->message( dirname + "/" + fi->fileName() );
		Tree->sons = ReadTree( dirname + "/" + fi->fileName() , Tree ) ;
        }

     ++it ;                            // goto next list element
     }
 return iTree ;
  
}
